<?php

if(!defined('_PS_VERSION_')
	OR !defined('_CAN_LOAD_FILES_')
)
{
	exit;
}

class ecm_price_by_mfg extends Module
{
	private $html = '';
	private $_postErrors = array();
	protected $_errors = false;

	public
	function __construct()
	{
		$this->name = 'ecm_price_by_mfg';
		$this->tab = 'content_management';
		$this->version = '0.2';
		$this->author = 'Elcommerce';
		$this->ps_versions_compliancy = array('min'=> '1.5','max'=> '1.6.10');
		$this->need_instance = 1;
		$this->module_key = "";

		parent::__construct();

		$this->displayName = $this->l('PriceByManufactures');
		$this->description = $this->l('Set price by manufactures');
	}

	public
	function install()
	{
		if(!parent::install()
		)
		{
			return FALSE;
		}
		return TRUE;
	}
	public
	function uninstall()
	{
		if(!parent::uninstall()
		)
		{
			return FALSE;
		}
		return TRUE;
	}

	public
	function runSql($sql)
	{
		foreach($sql as $s)
		{
			if(!Db::getInstance()->Execute($s))
			{
				return FALSE;
			}
		}
		return TRUE;
	}

	private
	function _postProcess()
	{
		$this->html .= '

		';
		return $this->html;
	}
	
	private
	function _displayabout()
	{

		$this->html .= "
		<fieldset>
		<legend>".$this->l('About')."</legend>
		<div id='dev_div'>
		<span><b>" . $this->l('Version') . ":</b> " . $this->version . "</span><br>
		<span><b>" . $this->l('author') . ":</b> <a class='link' href='mailto:A_Dovbenko@mail.ru' target='_blank'>Elcommerce</a>
		<p style='text-align:center'><a href='http://elcommerce.com.ua/' target='_blank'><img src='http://elcommerce.com.ua/img/m/logo.png' alt='Электронный учет коммерческой деятельности' /></a>
		</div>
		</fieldset>
		
		";
	}


	function getContent()
	{
		//$this->instanceDefaultStates();
		//$this->_postProcess();

		$id_lang_default = (int)Configuration::get('PS_LANG_DEFAULT');
		$id_shop_default = (int)Configuration::get('PS_SHOP_DEFAULT');

		$sql = "SELECT `id_manufacturer`,`name` FROM `ps_manufacturer`";
		$mfgs = Db::getInstance()->ExecuteS($sql);

		if((@$_POST['setprice'])){
			$pids = array();
			$mfg_id = (int)$_POST['mfg_id'];
			
			$procent = (int)$_POST['procent'];
			if($procent < 0) $sign = "-";
			else $sign     = "+";
			$sql = "UPDATE `ps_product` SET `price`=`wholesale_price`".$sign."(`wholesale_price`/100)*".abs($procent)." WHERE `id_manufacturer`=".$mfg_id;
			
			Db::getInstance()->Execute($sql);
			$sql = "SELECT `id_product` FROM `ps_product` WHERE `id_manufacturer`=".$mfg_id;
			$products = Db::getInstance()->ExecuteS($sql);
			if(!empty($products))
			{
				foreach($products as $product_id) $prod_ids[] = $product_id['id_product'];
				$prod_ids = implode (",", $prod_ids);
				$sql = "UPDATE `ps_product_shop` SET `price`=`wholesale_price`".$sign."(`wholesale_price`/100)*".abs($procent)." WHERE `id_product` IN ($prod_ids)";
				Db::getInstance()->Execute($sql);
				$sql = "UPDATE `ps_product_attribute` SET `price`=`wholesale_price`".$sign."(`wholesale_price`/100)*".abs($procent)." WHERE `id_product` IN ($prod_ids)";
				Db::getInstance()->Execute($sql);
				$sql = "SELECT `id_product_attribute` FROM `ps_product_attribute` WHERE `id_product` IN ($prod_ids)";
				$product_attributes = Db::getInstance()->ExecuteS($sql);
				if(!empty($product_attributes))
				{
					foreach($product_attributes as $product_attributes_id) $product_attributes_ids[] = $product_attributes_id['id_product'];
					$product_attributes_ids = implode (",", $product_attributes_ids);
					$sql = "UPDATE `ps_product_attribute_shop` SET `price`=`wholesale_price`".$sign."(`wholesale_price`/100)*".abs($procent)." WHERE `id_product_attribute` IN ($product_attributes_ids)";
					Db::getInstance()->Execute($sql);
				}
			}

		}

		if(Tools::isSubmit('setprice')){
		
		$this->html .= "
				<div class='conf confirm'>
				".$this->l('Prices succesfully update')."
				</div>";
		
		}
			
		$this->html .= "
		<h2>".$this->l('Increse/Decrese price by manufacturer')."</h2>
		<form method='POST' action=''>
		<table align='center'>
		<td width=55%>
		<fieldset>
		<legend>".$this->l('Settings')."</legend>
		<table align='center'>
		<tr>
		<td>
		<label for='mfg_id'>".$this->l('Manufacturer')."</label>
		</td>
		<td>
		<select name='mfg_id'>
		";
		foreach($mfgs as $mfg){
			$id_manufacturer = $mfg['id_manufacturer'];
			$name            = $mfg['name'];
			$this->html .= "<option value='$id_manufacturer'>$name</option>";
		}
		$this->html .= "
		</select>
		</td>
		</tr>
		<tr>
		<td>
		<label for='procent'>".$this->l('Change to')."&nbsp;</label>
		</td>
		<td>
		<input type='text' name='procent' value=0 size=3 />&nbsp;<b>%</b>
		</td>
		</tr>
		<tr>
		<td colspan=2>
		<div class='separation'></div>
		<p align='center'><input type='submit' name='setprice' value='&nbsp;&nbsp;".$this->l('GO!')."&nbsp;&nbsp;'/></p>
		</td>
		</tr>
		</table>
		</fieldset>
		</td>
		<td width=25%>
		";
		$this->html .= "
		</td>
		</table>
		</form>
		";
		$this->_displayabout();
		return $this->html;
	}
}
